part of oche;

/**
 * [OcheModule] is the base class for modules that handle routes.
 */
abstract class OcheModule {

  var _afterRoutePipeline = new RoutePipeline<AfterRouteAction>();
  var _beforeRoutePipeline = new RoutePipeline<BeforeRouteAction>();
  List<Route> _routes = new List<Route>();

  /// The [RoutePipeline] for adding [AfterRouteAction] actions.
  RoutePipeline<AfterRouteAction> get after => _afterRoutePipeline;

  /// The [RoutePipeline] for adding [BeforeRouteAction] actions.
  RoutePipeline<BeforeRouteAction> get before => _beforeRoutePipeline;

  /// Returns a new [Route] for 'GET' requests.
  Route get get => new Route('GET', this);

  /// Returns a new [Route] for 'POST' requests.
  Route get post => new Route('POST', this);

}